;-------------------------------------------------------------------------
; Copyright (c) 1999 Steven Freyder, David Helland, Bruce D. Lightner and
; Lightner Engineering.  Use subject to licensing restrictions described
; the file LICENSE.txt.  If you do not agree with the licensing terms then
; you must return and/or destroy this software immediately!
;-------------------------------------------------------------------------
;
; code to handle the getting/setting of the PicoWeb IP address
;

#if defined(EEPROM_IP)
;!!!!!!!!!!! vvv keep together vvv !!!!!!!!!!!! (used in bootp.asm)
.section eeprom
    .global eeprom_ip_addr
    .global eeprom_ip_gateway_addr
eeprom_ip_addr:            ; onboard storage for IP address and netmask
#include "ip.inc"
eeprom_ip_gateway_addr:    ; onboard storage for gateway IP address and netmask
#include "gw.inc"
;!!!!!!!!!!! ^^^ keep together ^^^ !!!!!!!!!!!!
#endif

.section reset

#if defined(STATIC_IP_MSB)
    movwi x,my_ip        ; hard code IP address
    movwi x,my_ip
    movwi y,STATIC_IP_MSB
    st x+,yh
    st x+,yl
    movwi y,STATIC_IP_LSB
    st x+,yh
    st x+,yl

#ifndef STATIC_NM_MSB
#define STATIC_NM_MSB 0
#define STATIC_NM_LSB 0
#endif
    movwi x,ip_netmask   ; hard code IP netmask
    movwi x,ip_netmask
    movwi y,STATIC_NM_MSB
    st x+,yh
    st x+,yl
    movwi y,STATIC_NM_LSB
    st x+,yh
    st x+,yl

#else /* !STATIC_IP_MSB */

#if defined(EEPROM_IP)
    movwi x,my_ip	  ; get IP address and netmask from on-chip eeprom
    ldi r18l,8            ; move 8 bytes (IP address and netmask!)
    movwi y,eeprom_ip_addr
    rcall ee2s

    movwi x,ip_gateway	  ; get default gateway IP address from on-chip eeprom
    ldi r18l,4            ; move 4 bytes
    movwi y,eeprom_ip_gateway_addr
    rcall ee2s

#else /* !EEPROM_IP */

#if defined(USE_BOOTP)
    movwi x,my_ip         ; use BOOTP
    ldi r18l,8            ; zero 8 bytes (IP and netmask)
    clr r0
bootp_zeroip:
    st x+,r0
    dec r18l
    brne bootp_zeroip

#else /* !USE_BOOTP */

#error "define USE_BOOTP, EEPROM_IP, or STATIC_IP_MSB"

#endif /* !USE_BOOTP */
#endif /* !EEPROM_IP */
#endif /* !STATIC_IP_MSB */

