;--------------------------------------------------------------------------
;+
; **-psgetcto-get characters from serial input queue with timeout
;
; psgetcto a,PSGETCTO_MSECS(msecs)
; psgetcto a,count
;
; inputs:
;   a     -> sram address to get byte
;   count = timeout loop count (use macro PSGETCTO_MSECS(msecs))
;   msecs = timeout in milliseconds
;
; outputs:
;   *a        : character read from serial input queue
;   flags Z=1 : character was ready
;         Z=0 : no characters where ready within specified timeout
;-
;--------------------------------------------------------------------------

#include "psgetcto.h"

.cseg
    .global psgetcto
psgetcto: pcode_routine 2
    clr r16               ; load 24-bit counter with (r12 << 8)
    movw y,r12            ; high 16 bits of counter in y
1:
    lds r17,com_in        ; +2 clks
    lds r18,com_out       ; +2 clks
    cp r17,r18            ; +1 clks
    brne 2f               ; +1 clks (char ready if com_in != com_out)

    dec r16               ; +1 clks
    brne 1b               ; +2 clks
                          ; =9 clks (set #define PSGETCTO_CLKS to this)

    rcall swdr            ; reset watchdog
    dec yl
    brne 1b
    dec yh
    brne 1b
    rjmp set_pcode_flags  ; Z=0...timeout exit

2:  rjmp ser_getc         ; char must be ready...return it via address in r10


